# -*- encoding: utf-8 -*-
# stub: openstudio-standards 0.6.1 ruby lib

Gem::Specification.new do |s|
  s.name = "openstudio-standards".freeze
  s.version = "0.6.1"

  s.required_rubygems_version = Gem::Requirement.new(">= 1.3.6".freeze) if s.respond_to? :required_rubygems_version=
  s.require_paths = ["lib".freeze]
  s.authors = ["Mark Adams".freeze, "Yeonjin Bae".freeze, "Carlo Bianchi".freeze, "Jeff Blake".freeze, "Yixing Chen".freeze, "Matthew Dahlhausen".freeze, "Carlos Duarte".freeze, "Sarah Gilani".freeze, "David Goldwasser".freeze, "Kamel Haddad".freeze, "Piljae Im".freeze, "Chris Kirney".freeze, "Matt Leach".freeze, "Xuechen (Jerry) Lei".freeze, "Jeremy Lerond".freeze, "Nicholas Long".freeze, "Phylroy Lopez".freeze, "Iain MacDonald".freeze, "Daniel Macumber".freeze, "Doug Maddox".freeze, "Mini Maholtra".freeze, "Julien Marrec".freeze, "Juan Gonzalez Matamoros".freeze, "Maria Mottillo".freeze, "Andrew Parker".freeze, "Padmassun Rajakareyar".freeze, "Eric Ringold".freeze, "Matt Steen".freeze, "Kaiyu Sun".freeze, "Weilie Xu".freeze, "Yunyang Ye".freeze, "Jian Zhang".freeze]
  s.date = "2024-05-17"
  s.description = "The openstudio-standards library provides methods for programatically generating, modifying, and checking OpenStudio building energy models. It can create a typical building from user geometry, template geometry, or programmatically generated geometry. It can apply a building standard including ASHRAE 90.1 or NECB to a model. It can transform a proposed building model into a 90.1 Appendix G code baseline model. It can check a model against a building standard. It can generate represenative typical buildings, such as those used in ComStock.".freeze
  s.email = ["matthew.dahlhausen@nrel.gov".freeze]
  s.homepage = "http://openstudio.net".freeze
  s.licenses = ["Modified BSD License".freeze]
  s.required_ruby_version = Gem::Requirement.new(">= 2.0.0".freeze)
  s.rubygems_version = "3.4.19".freeze
  s.summary = "Creates OpenStudio models of typical buildings, creates standard baselines from proposed models, and checks a model against a standard.".freeze

  s.installed_by_version = "3.4.19" if s.respond_to? :installed_by_version

  s.specification_version = 4

  s.add_development_dependency(%q<bundler>.freeze, ["~> 2.4.10"])
  s.add_development_dependency(%q<nokogiri>.freeze, ["~> 1.16"])
  s.add_development_dependency(%q<parallel_tests>.freeze, ["~> 3.7.0"])
  s.add_development_dependency(%q<aes>.freeze, ["= 0.5.0"])
  s.add_development_dependency(%q<codecov>.freeze, [">= 0"])
  s.add_development_dependency(%q<google_drive>.freeze, [">= 0"])
  s.add_development_dependency(%q<minitest>.freeze, ["~> 5.14.0"])
  s.add_development_dependency(%q<minitest-ci>.freeze, [">= 0"])
  s.add_development_dependency(%q<minitest-parallel_fork>.freeze, [">= 0"])
  s.add_development_dependency(%q<minitest-reporters>.freeze, ["~> 1.4.2"])
  s.add_development_dependency(%q<openstudio-api-stubs>.freeze, [">= 0"])
  s.add_development_dependency(%q<rake>.freeze, ["~> 13.0"])
  s.add_development_dependency(%q<rest-client>.freeze, ["~> 2.0.2"])
  s.add_development_dependency(%q<roo>.freeze, ["= 2.7.1"])
  s.add_development_dependency(%q<rubocop>.freeze, ["= 1.50"])
  s.add_development_dependency(%q<rubocop-checkstyle_formatter>.freeze, ["~> 0.6.0"])
  s.add_development_dependency(%q<ruby-progressbar>.freeze, [">= 0"])
  s.add_development_dependency(%q<rubyXL>.freeze, ["~> 3.4"])
  s.add_development_dependency(%q<simplecov>.freeze, ["= 0.22.0"])
  s.add_development_dependency(%q<yard>.freeze, ["~> 0.9"])
  s.add_runtime_dependency(%q<tbd>.freeze, ["~> 3"])
end
